//+------------------------------------------------------------------+
//|                                             wxShaunsBOLevels.mq4 |
//|                       Copyright ?2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright ?2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
 
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 BurlyWood
#property indicator_color2 BurlyWood
#property indicator_color3 MediumBlue
#property indicator_color4 MediumBlue
#property indicator_color5 Blue
#property indicator_color6 BurlyWood
#property indicator_color7 MediumBlue
#property indicator_color8 MediumBlue
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2

extern int MAX_BARS_BACK = 2000;
extern bool DoEntryAlerts= true;
extern int StartHour = 10;
extern int EndHour = 21;
extern int BreakoutBufferPips = 15;
extern double TPRatio = 1.2;
extern double TPRatio2 = 1.5;
extern bool BreakoutAlert = false;
extern color TextColour = White;

//extern int LondonEnd = 24;
int fontsize=7;

static datetime lastalerttime;
static double lastalertprice;

double Zone1Upper[];
double Zone1Lower[];
double TPUpper[];
double TPLower[];
double TPUpper2[];
double TPLower2[];

double MedianLine[];
double EntrySignalsBuffer[];
        

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Zone1Upper);
   SetIndexEmptyValue(0, 0.0);
	SetIndexLabel(0, "Entry Upper Zone");

   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,Zone1Lower);
   SetIndexEmptyValue(1, 0.0);
   SetIndexLabel(1, "Entry Lower Zone 1");

   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,TPUpper);
   SetIndexEmptyValue(2, 0.0);
   SetIndexLabel(2, "TP Upper Zone");

   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,TPLower);
   SetIndexEmptyValue(3, 0.0);
   SetIndexLabel(3, "TP Lower Zone");


   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4, 162);
   SetIndexBuffer(4, EntrySignalsBuffer);
   SetIndexEmptyValue(4, 0.0);
   SetIndexLabel(4, "Zone Breakout Signal");


   SetIndexStyle(5,DRAW_LINE); 
   SetIndexBuffer(5, MedianLine);
   SetIndexEmptyValue(5, 0.0);
	SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,1);


   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,TPUpper2);
   SetIndexEmptyValue(6, 0.0);
   SetIndexLabel(6, "TP Upper Zone 2");

   SetIndexStyle(7,DRAW_LINE);
   SetIndexBuffer(7,TPLower2);
   SetIndexEmptyValue(7, 0.0);
   SetIndexLabel(7, "TP Lower Zone 2");
   
	ArrayInitialize(Zone1Upper, 0);
	ArrayInitialize(Zone1Lower, 0);
	ArrayInitialize(TPUpper, 0);
	ArrayInitialize(TPLower, 0);
	ArrayInitialize(TPUpper2, 0);
	ArrayInitialize(TPLower2, 0);
	ArrayInitialize(MedianLine, 0);
   return(0);
}

int deinit()
{
	//ObjectsDeleteAll(0, OBJ_TREND);
   return(0);
}
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars= IndicatorCounted(),
         lastbar, result;
   
   int u, j;
   
   if (Bars<=100) 
      return(0);

	if(Period()>PERIOD_H1) return(0);

   if (counted_bars>0)
      counted_bars--;
      
   lastbar= Bars - counted_bars;
   
   //Comment("0", Zone1Upper[lastbar]);
   for(int i = MathMin(lastbar, MAX_BARS_BACK); i > -1; i--)
   {
   	//Tokyo
   	if(TimeHour(Time[i])>StartHour)
   	{
   		
   		if(TimeHour(Time[i+1])<=StartHour)
   		{
   			//find how many periods since the start of the period
				u = 60/Period()+1;
				int H1Bar = iBarShift(Symbol(), PERIOD_H1, Time[i], false)+1;
				double MedianPrice;
				if(iClose(Symbol(), PERIOD_H1, H1Bar) - iOpen(Symbol(), PERIOD_H1, H1Bar) > 0) MedianPrice = iHigh(Symbol(), PERIOD_H1, H1Bar);
				else MedianPrice = iLow(Symbol(), PERIOD_H1, H1Bar);
				

   			for(j = 1; j<u; j++)
   			{
   				Zone1Upper[i+j] = MedianPrice + BreakoutBufferPips*Point;
   				Zone1Lower[i+j] = MedianPrice - BreakoutBufferPips*Point;
   				MedianLine[i+j] = MedianPrice;
   			}
   			
   			TPUpper[i] = Zone1Upper[i+1] + BreakoutBufferPips*Point*2*TPRatio;
   			TPLower[i] = Zone1Lower[i+1] - BreakoutBufferPips*Point*2*TPRatio;
   			TPUpper2[i] = Zone1Upper[i+1] + BreakoutBufferPips*Point*2*TPRatio2;
   			TPLower2[i] = Zone1Lower[i+1] - BreakoutBufferPips*Point*2*TPRatio2;
  				Zone1Upper[i] = Zone1Upper[i+1];
  				Zone1Lower[i] = Zone1Lower[i+1];
  				MedianLine[i] = MedianLine[i+1];
   			
   		}else
   		{
   			if(TimeHour(Time[i])<=EndHour)
   			{
   				Zone1Upper[i] = Zone1Upper[i+1];
   				Zone1Lower[i] = Zone1Lower[i+1];
   				TPUpper[i] = TPUpper[i+1];
   				TPLower[i] = TPLower[i+1];
   				TPUpper2[i] = TPUpper2[i+1];
   				TPLower2[i] = TPLower2[i+1];
   				MedianLine[i] = MedianLine[i+1];
   			}
   		}
   	}

		if(BreakoutAlert)
		{
         CheckSignal(i, Zone1Upper[i], OP_BUY, EntrySignalsBuffer);
         CheckSignal(i, Zone1Lower[i], OP_SELL, EntrySignalsBuffer);
         CheckSignal(i, TPUpper[i], OP_BUY, EntrySignalsBuffer);
         CheckSignal(i, TPLower[i], OP_SELL, EntrySignalsBuffer);
		}
   }
   
   if(MedianLine[0] != 0)
   {
   CreateText("Zone1Upper", Zone1Upper[0]);
   CreateText("Zone1Lower", Zone1Lower[0]);
   CreateText("TPUpper", TPUpper[0]);
   CreateText("TPLower", TPLower[0]);
   CreateText("TPUpper2", TPUpper2[0]);
   CreateText("TPLower2", TPLower2[0]);
   CreateText("MedianLine", MedianLine[0]);
	}
	
   //
   // check alerts   
   //
   if (DoEntryAlerts && lastalerttime!=Time[0] && EntrySignalsBuffer[0]!=0 && EntrySignalsBuffer[0]!=lastalertprice) {
      Alert(Symbol(), " ORB signals entry!");
      lastalerttime= Time[0];
      lastalertprice= EntrySignalsBuffer[0];
   }


   return(0);
}

  

//+------------------------------------------------------------------+
//| Check price break                                                |
//+------------------------------------------------------------------+
bool CheckSignal(int shift, double price, int type, double &signalbuffer[]) 
{
   bool signal= false;

   if (type==OP_BUY && ((Open[shift]<price && High[shift]>price) || (Close[shift+1]<price && Open[shift]>price)) ) {
      signalbuffer[shift]= price;
      signal= true;
  }

   if (type==OP_SELL && (Open[shift]>price && Low[shift]<price) || (Close[shift+1]>price && Open[shift]<price)) {
      signalbuffer[shift]= price;
      signal= true;
  }
  
  return (signal);
}



void CreateText(string Name, double Value)
{
	ObjectCreate(Name, OBJ_TEXT, 0, 0, 0);
	ObjectSetText(Name, "              " + DoubleToStr(Value, Digits),fontsize,"Arial",TextColour);
	ObjectMove(Name, 0, Time[0],Value);
}